%%
% Author: Chenzhe Qian
% Team: iGEM 2012 Calgary
% Source code are governed under the BioBrick?s Foundation and iGEM 2012 copyright policies
%%

function varargout = FVAapp(varargin)
% FVAapp MATLAB code for FVAapp.fig
%      FVAapp, by itself, creates a new FVAapp or raises the existing
%      singleton*.
%
%      H = FVAapp returns the handle to a new FVAapp or the handle to
%      the existing singleton*.
%
%      FVAapp('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FVAapp.M with the given input arguments.
%
%      FVAapp('Property','Value',...) creates a new FVAapp or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before FVAapp_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to FVAapp_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help FVAapp

% Last Modified by GUIDE v2.5 02-Oct-2012 21:32:14

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @FVAapp_OpeningFcn, ...
                   'gui_OutputFcn',  @FVAapp_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before FVAapp is made visible.
function FVAapp_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to FVAapp (see VARARGIN)

% Choose default command line output for FVAapp
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

%Initial GUI
initialize_gui(hObject, handles, false, '');

% inital fvaapp toolbox
initCobraToolbox;

% UIWAIT makes FVAapp wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Executes during object creation, after setting all properties.
function modelLoaded_CreateFcn(hObject, eventdata, handles)

function varargout = FVAapp_OutputFcn(hObject, eventdata, handles) 
varargout{1} = handles.output;


function analysisTab_Callback(hObject, eventdata, handles)
set(handles.buildPanel,'Visible','Off');
set(handles.analysisPanel,'Visible','On');

function buildTab_Callback(hObject, eventdata, handles)
set(handles.buildPanel,'Visible','On');
set(handles.analysisPanel,'Visible','Off');

function pathway_Callback(hObject, eventdata, handles)
pathwayNames = get(hObject, 'String');
pathwayIndex = get(hObject, 'Value');
handles.guiData.selectedPathway = pathwayNames{pathwayIndex};
handles.guiData.selectedPathway = strrep(handles.guiData.selectedPathway,'.m','');
guidata(hObject,handles);

function pathway_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function numberOfApproxPoints_Callback(hObject, eventdata, handles)
handles.guiData.numberOfApproxPoints = str2double(get(hObject, 'String'));
guidata(hObject,handles);

function numberOfApproxPoints_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function polyDegree_Callback(hObject, eventdata, handles)
handles.guiData.polyDegree = str2double(get(hObject, 'String'));
guidata(hObject,handles);

function polyDegree_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function diffThreshold_Callback(hObject, eventdata, handles)
handles.guiData.diffThreshold = str2double(get(hObject, 'String'));
guidata(hObject,handles);

function diffThreshold_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function zerosThreshold_Callback(hObject, eventdata, handles)
handles.guiData.zerosThreshold = str2double(get(hObject, 'String'));
guidata(hObject,handles);

function zerosThreshold_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function effectors_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in runButton.
function runButton_Callback(hObject, eventdata, handles)
fprintf('pathway:%s, numOfApproxPoint:%d, polydegree:%d, diffThreshold:%f, zerosThreshold:%f\n',...
    handles.guiData.selectedPathway,handles.guiData.numberOfApproxPoints,handles.guiData.polyDegree,...
    handles.guiData.diffThreshold,handles.guiData.zerosThreshold);

if (handles.guiData.resetFlag == 0)
    msgbox('Please reset the system first','Error');
    return;
end
    
if isempty(handles.guiData.oriModel)
    msgbox('Please load a model','Error');
    return;
elseif strcmp(handles.guiData.selectedPathway,'')
    msgbox('Please select a model','Error');
    return;
else
    %get any pathway function stored in Pathway folder 
    cd Pathway/;
    f = str2func(handles.guiData.selectedPathway);
    model = f(handles.guiData.oriModel);
    cd ../;
    
    [effectors oriGlucose oriBiomass maxFlux sol funcF biomasses] = main(model,handles.guiData.numberOfApproxPoints,handles.guiData.polyDegree,handles.guiData.diffThreshold,handles.guiData.zerosThreshold,false);
    handles.guiData.effectors = {};
    handles.guiData.effectors{1} = {'Standard', oriGlucose, 0, oriBiomass, maxFlux, 0};
%     disp(handles.guiData.effectors{1});
%     disp(effectors);
    handles.guiData.effectors = [handles.guiData.effectors{1}; effectors];
    set(handles.effectors,'Data',handles.guiData.effectors);
%     disp(handles.guiData.effectors);

    axes(handles.plot);
    cla;
    fplot(funcF,[biomasses(1) biomasses(end)]);
    hold all
    plot(sol, funcF(sol),'Marker','o','Color',[1 0 0],'MarkerSize',10);
    xlabel('Biomass flux rate (mmol/h/ml/DWg)');
    ylabel('Target compound flux rate (mmol/h/ml/DWg)');
    handles.guiData.resetFlag = 0;
end

guidata(hObject,handles);

% --- Executes on button press in analyzeResetButton.
function analyzeResetButton_Callback(hObject, eventdata, handles)
tab = 'analyze';
initialize_gui(gcbf, handles, true, tab);


% --------------------------------------------------------------------



function loadButton_Callback(hObject, eventdata, handles)
% handles.guiData.oriModel = readCbModel('/Users/adamyingzi/Desktop/iGEM/Modelling/microbeModels/Ecoli/iAF1260/Ec_iAF1260_flux1.xml');
handles.guiData.oriModel = readCbModel();
% disp(handles.guiData.oriModel);
if length(handles.guiData.oriModel) > 0
    set(handles.modelLoaded,'Value',1);
    handles.guiData.possibleCompounds = horzcat(handles.guiData.oriModel.mets, handles.guiData.oriModel.metNames);
    set(handles.possibleCompoundTable, 'Data', handles.guiData.possibleCompounds);
    set(handles.filterButton,'enable','on');
    set(handles.modelLoaded,'String', [handles.guiData.oriModel.description ' loaded']);
    guidata(hObject,handles);
else
    errordlg('Loading failed','Error');
    return;
end


% --- Executes on button press in exportButton.
function exportButton_Callback(hObject, eventdata, handles)
[FileName,PathName] = uiputfile('*.txt','Save As');
filename = fullfile(PathName, FileName);
fid = fopen(filename,'w');
fprintf(fid, '%s\n\n', handles.guiData.selectedPathway);
fprintf(fid, '%s\t %s\t %s\t %s\t %s\t %s\n',...
    'Metabolic Names', 'Glucose Flux Rate', 'Added Metabolite Flux Rate', 'Biomass Flux Rate','Target Compound Flux Rate','Values(%)');
for i = 1:length(handles.guiData.effectors)
    fprintf(fid, '%s\t %f\t %f\t %f\t %f\t %f\n',...
        handles.guiData.effectors{i,1}, handles.guiData.effectors{i,2}, handles.guiData.effectors{i,3}, handles.guiData.effectors{i,4}, handles.guiData.effectors{i,5}, handles.guiData.effectors{i,6});
end
fclose(fid);





% ---Initialization---------------------------------------------------
%
%
function initialize_gui(fig_handle, handles, isreset, tab)
% General init
clear handles.guiData;
if isfield(handles, 'guiData') && ~isreset
    return;
end

if ~isreset
    set(handles.modelLoaded,'Value',0);
    handles.guiData.oriModel = struct([]);
end

if exist('Pathway','dir') ~= 7
    mkdir('Pathway')
end

if isempty(tab)
    set(handles.buildPanel,'Visible','on');
    set(handles.analysisPanel,'Visible','Off');
    set(handles.buildTab, 'Value', 1);
    set(handles.analysisTab, 'Value', 0);
end

if strcmp(tab,'analyze') || isempty(tab)
    % Analysis Tab init
    p = what('Pathway');
    if ~isempty(p.m)
        handles.guiData.selectedPathway = p.m(1);
        handles.guiData.selectedPathway = strrep(handles.guiData.selectedPathway,'.m','');
    else
        handles.guiData.selectedPathway = '';
    end

    handles.guiData.resetFlag = 1;
%     handles.guiData.model = {'','decarb','desulf','denitri'};
    handles.guiData.numberOfApproxPoints = 5;
    handles.guiData.polyDegree = 3;
    handles.guiData.diffThreshold = 1;
    handles.guiData.zerosThreshold = 1e-5;
    handles.guiData.effectors = {};

    p.m = [' '; p.m];
    set(handles.pathway, 'String', p.m);
    set(handles.pathway, 'Value', 1);
    set(handles.numberOfApproxPoints,  'String', handles.guiData.numberOfApproxPoints);
    set(handles.polyDegree , 'String', handles.guiData.polyDegree);
    set(handles.diffThreshold, 'String', handles.guiData.diffThreshold);
    set(handles.zerosThreshold, 'String', handles.guiData.zerosThreshold);
    set(handles.effectors,'Data',handles.guiData.effectors);
    % test0 = {'sfgs',2;'fgs',3;'dsgdsg',0};
    % test1 = {'sgs';'fdgdh';'sdgsd'};
    % test2 = {0.35436;0.3467;0.123};
    % test = [test1,test2];
    % for i = 1:length(test1)
    %     test{end+1} = {test1{i},test2{i}};
    % end

    axes(handles.plot);
    cla;
    xlabel('Biomass flux rate (mmol/h/ml/DWg)');
    ylabel('Target compound flux rate (mmol/h/ml/DWg)');
end;




if strcmp(tab,'build') || isempty(tab)
    % Build Tab init
    handles.guiData.possibleCompounds = {};
    handles.guiData.reactants = {};
    handles.guiData.products = {};
    handles.guiData.reactions = {};
    handles.guiData.metab = '';
    handles.guiData.coefficient = 1;
    handles.guiData.lowerBound = -1000;
    handles.guiData.upperBound = 1000;
    handles.guiData.compartment = '';
    handles.guiData.reversible = true;
    handles.guiData.metaAbbr = '';
    handles.guiData.metaDesp = '';
    handles.guiData.roleIndicator = '';
    handles.guiData.rxnNameList = {};
    handles.guiData.formulaList = {};
    handles.guiData.possibleCompounds = {};
    
    set(handles.rxnNameField, 'String' ,'');
    set(handles.coefficientField, 'String', '1');
    set(handles.possibleCompoundTable,'Data',handles.guiData.possibleCompounds);
    set(handles.reactantTable,'Data',handles.guiData.reactants);
    set(handles.productTable,'Data',handles.guiData.products);
    set(handles.reactionTable,'Data',handles.guiData.reactions);
    set(handles.roleIndicatorGroup, 'SelectionChangeFcn',@roleSelection);
end

guidata(handles.figure1, handles);


function roleSelection(source,eventdata)
disp(get(get(source,'SelectedObject'),'String'));


% --------------------------------------------------------------------











function compartmentList_Callback(hObject, eventdata, handles)

function compartmentList_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes on button press in addMetButton.
function addMetButton_Callback(hObject, eventdata, handles)
metab = get(handles.searchField,'String');
metab_coefficient = get(handles.coefficientField,'String');
metab_coefficient = str2double(metab_coefficient);
compartments = get(handles.compartmentList,'String');
compart_index = get(handles.compartmentList,'Value');
metab_compartment = compartments{compart_index};

if isempty(metab) % If no metabolite is selected
    msgbox('You have to add a metabolite');
    return
elseif  metab_coefficient <= 0 || metab_coefficient >= 1000 % if coefficient is not valid
    msgbox('Coefficient must be a number larger than 0 and smaller than 1000');
    return
else
end

handles.guiData.roleIndicator = get(get(handles.roleIndicatorGroup,'SelectedObject'),'String');
% disp([handles.guiData.roleIndicator, ' ' ,metab, ' ', metab_coefficient, ' ', metab_compartment, ' ', handles.guiData.roleIndicator]);
if (strcmp(handles.guiData.roleIndicator,'Reactants'))
    handles.guiData.reactants  = [handles.guiData.reactants; {metab, metab_coefficient, metab_compartment}];
    set(handles.reactantTable,'Data', handles.guiData.reactants);
else
    handles.guiData.products = [handles.guiData.products; {metab, metab_coefficient, metab_compartment}];
    set(handles.productTable,'Data',handles.guiData.products);
end

guidata(hObject,handles)



function createButton_Callback(hObject, eventdata, handles)
lb = get(handles.lowerBoundField,'String');
ub = get(handles.upperBoundField,'String');
rxnName = get(handles.rxnNameField,'String');

% check reactions with same name
if(ismember(rxnName,handles.guiData.rxnNameList))
    msgbox('A reaction with same name is already exist');
    return ;
else
    handles.guiData.rxnNameList{end+1} = rxnName;
end

% reaction name cannot be blank
if isempty(rxnName)
    msgbox('Please enter reaction name');
    return;
end

% get reversibility value
if (get(handles.reverseIndicator,'Value') == get(handles.reverseIndicator,'Max'))
    rev = 'true';
else
    rev = 'false';
end

formula  = '';
% add reactants
reactlen = size(handles.guiData.reactants);
disp(handles.guiData.reactants);
for i=1:reactlen(1)
    if strcmp(handles.guiData.reactants{i,3},'Cytoplasm')
        handles.guiData.reactants{i,1} = [handles.guiData.reactants{i,1} '[c]'];
    elseif strcmp(handles.guiData.reactants{i,3},'Extracellular')
        handles.guiData.reactants{i,1} = [handles.guiData.reactants{i,1} '[e]'];
    elseif strcmp(handles.guiData.reactants{i,3},'Boundary')
        handles.guiData.reactants{i,1} = [handles.guiData.reactants{i,1} '[b]'];
    end
    
    % add last product
    if i==reactlen(1)
        if strcmp(rev,'true')
            formula = [formula num2str(handles.guiData.reactants{i,2}) ' ' handles.guiData.reactants{i,1} ' <=> '];
        else
            formula = [formula num2str(handles.guiData.reactants{i,2}) ' ' handles.guiData.reactants{i,1} ' -> '];
        end
        break;
    end
    
    formula = [formula num2str(handles.guiData.reactants{i,2}) ' ' handles.guiData.reactants{i,1} ' + '];
end

% add products
prodlen = size(handles.guiData.products);
for i=1:prodlen(1)
    if strcmp(handles.guiData.products{i,3},'Cytoplasm')
        handles.guiData.products{i,1} = [handles.guiData.products{i,1} '[c]'];
    elseif strcmp(handles.guiData.products{i,3},'Extracellular')
        handles.guiData.products{i,1} = [handles.guiData.products{i,1} '[e]'];
    elseif strcmp(handles.guiData.products{i,3},'Boundary')
        handles.guiData.products{i,1} = [handles.guiData.products{i,1} '[b]'];
    end
    
    % add last product
    if i==prodlen(1)
        formula = [formula num2str(handles.guiData.products{i,2}) ' ' handles.guiData.products{i,1}];
        break;
    end
    
    formula = [formula num2str(handles.guiData.products{i,2}) ' ' handles.guiData.products{i,1} ' + '];
end

if(ismember(formula,handles.guiData.formulaList))
    msgbox('A reaction with same formula is already exist');
    return ;
else
    handles.guiData.formulaList{end+1} = formula;
end

handles.guiData.reactions = [handles.guiData.reactions; {rxnName, formula, rev, lb, ub}];
set(handles.reactionTable,'Data',handles.guiData.reactions);

% clean prod/react tables
set(handles.productTable,'Data',{});
set(handles.reactantTable,'Data',{});
handles.guiData.products = {};
handles.guiData.reactants = {};
set(handles.rxnNameField, 'String' ,'');

% disp([rxnName, ' ', formula, ' ', lb, ' ', ub, ' ', rev]);
guidata(hObject,handles);


function pathwayExportButton_Callback(hObject, eventdata, handles)
[FileName,PathName] = uiputfile('*.m','Save As','./Pathway/');
disp(FileName);
if isempty(FileName)
    return;
end

filename = fullfile(PathName, FileName);
fid = fopen(filename,'w');
FileName = strrep(FileName,'.m','');
pathwayName = [FileName 'Model'];
fprintf(fid, 'function %s = %s(model) \n\n', pathwayName, FileName);
% fprintf(fid, 'numOfRxns = %d;\n', length(handles.guiData.reactions));
fprintf(fid, '%s = model;\n', pathwayName);
% fprintf(fid, 'for i = 1:numOfRxns\n');
reactionsLen = size(handles.guiData.reactions);
for i = 1:reactionsLen(1)
    fprintf(fid, '%s = addReaction(%s, ''%s'', ''%s'', [], %s, %s, %s);\n',...
        pathwayName, pathwayName, handles.guiData.reactions{i,1}, handles.guiData.reactions{i,2},handles.guiData.reactions{i,3},handles.guiData.reactions{i,4}, handles.guiData.reactions{i,5});
end
% fprintf(fid, 'end');
fclose(fid);

%refresh the dir index
p = what('Pathway');
handles.guiData.selectedPathway = p.m(1);
p.m = [' '; p.m];
set(handles.pathway, 'String', p.m);
set(handles.pathway, 'Value', 1);



function filterButton_Callback(hObject, eventdata, handles)
searchCompound = get(handles.searchField,'String');
abbrNameLen = size(handles.guiData.possibleCompounds);
fullNameLen = size(handles.guiData.possibleCompounds);
compoundsAbbrName = (handles.guiData.possibleCompounds(1:abbrNameLen(1)))';
compoundsFullName = (handles.guiData.possibleCompounds((fullNameLen(1)+1):end))';

[tf, indAbbr] = ismember(searchCompound,compoundsAbbrName);
[tf, indFull] = ismember(searchCompound,compoundsFullName);

if(indAbbr > 0)
%     handles.guiData.possibleCompounds = [compoundsAbbrName(indAbbr), compoundsFullName(indAbbr)];
    set(handles.possibleCompoundTable, 'Data', [compoundsAbbrName(indAbbr), compoundsFullName(indAbbr)]);
elseif(indFull > 0)
%     handles.guiData.possibleCompounds = [compoundsAbbrName(indFull), compoundsFullName(indFull)];
    set(handles.possibleCompoundTable, 'Data', [compoundsAbbrName(indFull), compoundsFullName(indFull)]);
elseif(eq(indAbbr,0) && eq(indFull,0))
%     handles.guiData.possibleCompounds = horzcat(handles.guiData.oriModel.mets, handles.guiData.oriModel.metNames);
    set(handles.possibleCompoundTable, 'Data', handles.guiData.possibleCompounds);
end

guidata(hObject,handles);



function searchField_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function coefficientField_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function lowerBoundField_Callback(hObject, eventdata, handles)

function lowerBoundField_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function upperBoundField_Callback(hObject, eventdata, handles)

function upperBoundField_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function buildResetButton_Callback(hObject, eventdata, handles)
tab = 'build';
initialize_gui(gcbf, handles, true, tab);

function rxnNameField_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function updateButton_Callback(hObject, eventdata, handles)
handles.guiData.reactions = get(handles.reactionTable,'Data');
disp(handles.guiData.reactions);
guidata(hObject,handles);


function reactionTable_CellEditCallback(hObject, eventdata, handles)

function analysisTab_CreateFcn(hObject, eventdata, handles)

function buildTab_CreateFcn(hObject, eventdata, handles)

function effectors_Callback(hObject, eventdata, handles)

function FVAapp_Callback(hObject, eventdata, handles)

function loadButton_CreateFcn(hObject, eventdata, handles)

function searchField_Callback(hObject, eventdata, handles)

function reverseIndicator_Callback(hObject, eventdata, handles)

function coefficientField_Callback(hObject, eventdata, handles)

function rxnNameField_Callback(hObject, eventdata, handles)
