%%
% Author: Chenzhe Qian
% Team: iGEM 2012 Calgary
% Copy Rights Reversed
%%

function luxModel = LuxR(model)

% LuxAB:  luciferase -- an aldehyde + FMNH2 + oxygen <=> h? + a carboxylate + FMN + H2O + 2 H+
% LuxCDE: sythetase, transferases, reductase 
% LuxC--Long-chain aldehyde + CoA + NADP+ <=> Long-chain acyl-CoA + NADPH + H+
% LuxD--
% LuxE--ATP + Acid + Protein <=> AMP + Diphosphate + Acyl-protein thioester 
% LuxCDE--ATP + NADPH + H + acid <=> AMP + ppi + NADP + aldehyde


% rxnNamesList = {'substrateImport','substrateTrans','LuxAB','acid terimal'};
% rxnsList = {'decanal[e] <=>',...
%             'decanal[e] <=> decanal[c]',...
%             'decanal[c] + fmnh2[c] + o2[c] <=> hv[c] + decaonic[c] + fmn[c] + h2o[c] + 2 h[c]',...
%             'decaonic[c] ->'};
        

rxnNamesList = {'substrateImport','substrateTrans','LuxCDEwP', 'LuxCDE', 'LuxAB','Terminal'};

rxnsList = {'decanoic[e] <=>',...
            'decanoic[e] <=> decanoic[c]',...
            'decanoic[c] + atp[c] + nadph[c] + h[c] <=> decanal[c] + amp[c] + ppi[c] + nadp[c]',...
            'decanoic[c] + atp[c] + nadh[c] + h[c] <=> decanal[c] + amp[c] + ppi[c] + nad[c]',...
            'decanal[c] + fmnh2[c] + o2[c] <=> hv[c] + decanoic[c] + fmn[c] + h2o[c] + 2 h[c]',...
            'hv[c] ->'};   
                
luxModel = model;
for i = 1:length(rxnNamesList)
    luxModel = addReaction(luxModel,rxnNamesList{i}, rxnsList{i});
    if i == length(rxnNamesList)
        luxModel = addReaction(luxModel,rxnNamesList{i}, rxnsList{i},[],0,0);
    end
end

% testPathway(luxModel,'decaonic[e]','hv[c]');
