%%
% Author: Chenzhe Qian
% Team: iGEM 2012 Calgary
% Source code are governed under the BioBrick?s Foundation and iGEM 2012 copyright policies
%%

%% function to test all candidates
function effectors = candidatesTest(model,candidates,bioPercent,oriMaxRate,oriBiomass,negFlag)
% fprintf('original rate:%f original biomass:%f \n', oriMaxRate, oriBiomass);
effectors = {};
values = {};
biomasses = {};
tFluxRate = {};
glucoseRate = {};
addedMetRate = {};

h = waitbar(0,'Testing candidates compound...');
for i = 1:length(candidates)
    waitbar(i/length(candidates),h);
    text = textscan(candidates{i},'%s');
    metName = text{1}{1};
    score = str2double(text{1}{2});
    rxnName = text{1}{3};
    rxnID = findRxnIDs(model,rxnName);
%     fprintf('%s\n',rxnName);
%     fprintf('met:%s score:%f\n',metName,score);
    if (score > 0)
        if (model.lb(rxnID) == 0)
            newModel = changeRxnBounds(model,rxnName,-1000,'l');
            [min max biomass xMin xMax] = fluxVariabilityCus(newModel, bioPercent, 'max', newModel.rxns(end), false, false); 
%             fprintf('changed rxn:%s rate:%f biomass:%f \n',rxnName,max,biomass);
            if(negFlag == false)
                if(max*biomass > oriMaxRate*oriBiomass)
                    values{end+1} = (max*biomass - oriMaxRate*oriBiomass) / oriMaxRate*oriBiomass * 100;
                    glucoseRate{end+1} = xMax(findRxnIDs(model,'EX_glc(e)'));
                    addedMetRate{end+1} = xMax(findRxnIDs(model,rxnName));
                    biomasses{end+1} = biomass;
                    tFluxRate{end+1} = max;
    %                 fprintf('effector found:%s, biomass:%f, Trate:%f, values:%f\n',...
    %                     metName, biomasses{end}, tFluxRate{end}, values{end});
                    effectors{end+1} = metName;
                    candidates{i} = [];
                end
            else
                if(max < oriMaxRate)
                    values{end+1} = (max*biomass - oriMaxRate*oriBiomass) / oriMaxRate*oriBiomass * 100;
                    glucoseRate{end+1} = xMax(findRxnIDs(model,'EX_glc(e)'));
                    addedMetRate{end+1} = xMax(findRxnIDs(model,rxnName));
                    biomasses{end+1} = biomass;
                    tFluxRate{end+1} = max;
    %                 fprintf('effector found:%s, biomass:%f, Trate:%f, values:%f\n',...
    %                     metName, biomasses{end}, tFluxRate{end}, values{end});
                    effectors{end+1} = metName;
                    candidates{i} = [];
                end
            end
        end
    end
end

effectors = effectors';
effectors = abbrNametoFullName(model,effectors);
glucoseRate = glucoseRate';
addedMetRate = addedMetRate';
biomasses = biomasses';
tFluxRate = tFluxRate';
values = values';
effectors = [effectors, glucoseRate, addedMetRate, biomasses, tFluxRate, values];
disp(effectors);

candidates = candidates(~cellfun('isempty',candidates));
disp(candidates);

close(h);

%% helper function convert abbr. names to full names
function fullNames = abbrNametoFullName(model,abbrNames)
fullNames = {};
for i = 1:length(abbrNames)
    abbrNames{i} = [abbrNames{i} '[c]'];
    indexArray = ismember(model.mets,abbrNames(i));
    metName = char(model.metNames(logical(indexArray)));
    fullNames{end+1} = metName;
end
fullNames = fullNames';
%%



