%%
% Author: Chenzhe Qian
% Team: iGEM 2012 Calgary
% Source code are governed under the BioBrick?s Foundation and iGEM 2012 copyright policies
%%

%% function to trace back to the initial media sources from interested mets list
function candidates = traceSource(model,metsList)

candidates = {};
exRxns = extractExRxns(model);

% get all initial uptaken mets from interested mets list
for i = 1:length(metsList)
    % to make the met name unique
    str = ['EX_' strtok(metsList{i}) '(e)'];
    indexArray = strfind(exRxns,str);
    index = find(not(cellfun('isempty', indexArray)));
    if index ~= 0
%          fprintf('met:%s, rxn:%s \n',metsList{i}, exRxns{index});
        rxnID = findRxnIDs(model,str);
        candidates{end+1} = [metsList{i} ' ' str];
        metsList{i} = [];
    end
end

candidates = candidates';
disp(['origin candidates:'; candidates]);

%% following functions are helpers called in above
% helper to get all exchange function from model
function exRxns = extractExRxns(model)
exRxns = {};
for i = 1:length(model.rxns)
    if ~isempty(strfind(model.rxns{i},'EX_'))
        exRxns{end+1} = model.rxns{i};
    end
end
exRxns = exRxns';


%% End of function